<!DOCTYPE>

<html>

  <head>
    <title>GrafoApp</title>

    <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1, maximum-scale=1">

    <script src="https://unpkg.com/cytoscape/dist/cytoscape.min.js"></script>

    <!-- for testing with local version of cytoscape.js -->
    <!--<script src="../cytoscape.js/build/cytoscape.js"></script>-->

    <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.10/lodash.js"></script>
    <script src="cytoscape-edgehandles.js"></script>

    <style>
      body {
        font-family: helvetica neue, helvetica, liberation sans, arial, sans-serif;
        font-size: 14px;
      }

      #cy {
        position: absolute;
        left: 0;
        top: 0;
        bottom: 0;
        right: 0;
        z-index: 999;
      }

      h1 {
        opacity: 0.5;
        font-size: 1em;
        font-weight: bold;
      }

      #aristas {
        position: absolute;
        z-index: 99999;
        margin: 1em;
        margin-top: 2.5cm;
      }
      #aristas2 {
        position: absolute;
        z-index: 99999;
        margin: 1em;
        margin-top: 3.5cm;
      }

      #crear{
        position: absolute;
        z-index: 99999;
        margin: 1em;
      }
      #nodos {
        position: absolute;
        z-index: 99999;
        margin: 1em;
        margin-top: 1.5cm;
        
      }

      .menu{
        background-color: red;
        text-align: center;
      }

      .btn{
        cursor: pointer;
        position: relative;
        background-color: gray;
        color: red;
        border: 2px solid black;
      }
      .btn:hover{
        background-color: black;
        border: 2px solid gray;
        color: white;
        transition: 2s ease;
      }
      


    </style>

    <script>
      document.addEventListener('DOMContentLoaded', function(){

        var cy = window.cy = cytoscape({
          container: document.getElementById('cy'),

          layout: {
            name: 'concentric',
            concentric: function(n){ return n.id() === 'j' ? 200 : 0; },
            levelWidth: function(nodes){ return 100; },
            minNodeSpacing: 100
          },

          style: [
            {
              selector: 'node[name]',
              style: {
                'content': 'data(name)'
              }
            },

            {
              selector: 'edge',
              style: {
                'curve-style': 'bezier',
                "label": "data(label)"
//                'target-arrow-shape': 'triangle'
              }
            },

            // some style for the extension

            {
              selector: '.eh-handle',
              style: {
                'background-color': 'red',
                'width': 12,
                'height': 12,
                'shape': 'ellipse',
                'overlay-opacity': 0,
                'border-width': 12, // makes the handle easier to hit
                'border-opacity': 0
              }
            },

            {
              selector: '.eh-hover',
              style: {
                'background-color': 'red'
              }
            },

            {
              selector: '.eh-source',
              style: {
                'border-width': 2,
                'border-color': 'red'
              }
            },

            {
              selector: '.eh-target',
              style: {
                'border-width': 2,
                'border-color': 'red'
              }
            },

            {
              selector: '.eh-preview, .eh-ghost-edge',
              style: {
                'background-color': 'red',
                'line-color': 'red',
                'target-arrow-color': 'red',
                'source-arrow-color': 'red'
              }
            },

            {
              selector: '.eh-ghost-edge.eh-preview-active',
              style: {
                'opacity': 0
              }
            }
          ],

          elements: {
            nodes: [
              { data: { id: 'j', name: 'J' } },
              { data: { id: 'e', name: 'E' } }
            ],
            edges: [
              { data: { source: 'j', target: 'e', label: 3 } },
              { data: { source: 'e', target: 'j', label: 5 } }
            ]
          }

          
        });

        var eh = cy.edgehandles({
          snap: false
        });

        document.querySelector('#draw-on').addEventListener('click', function() {
          eh.enableDrawMode();
        });

        document.querySelector('#draw-off').addEventListener('click', function() {
          eh.disableDrawMode();
        });

        /*
        document.querySelector('#start').addEventListener('click', function() {
          eh.start( cy.$('node:selected') );
        });
        */
        document.querySelector('#delete').addEventListener('click', function() {
          cy.$('node:selected').remove();
        });

        document.querySelector('#deleteAr').addEventListener('click', function() {
          cy.$('edge:selected').remove();
        });

        document.querySelector('#asignar_valor').addEventListener('click', function() {
          cy.$('edge:selected').data("label", document.querySelector('#nombre_arista').value )
         })

        document.querySelector('#create').addEventListener('click', function() {
        cy.add({
            group: 'nodes',
            data: { id: document.querySelector('#nombre').value, name: document.querySelector('#nombre').value },
            position: { x: 700, y: 350 }
          })
        });

      });
    </script>
  </head>

  <body>
    <div id="cy"></div>
       
    <div class="menu">
      <p style="font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif; font-size: x-large;">GRAFO APP</p>
      <div id="crear">
        <input  id="nombre" type="text" >
        <button class="btn" id="create">Crear Nodo</button>
      </div>
      <div id="nodos">
        <button class="btn" id="draw-off">Mover Nodo</button>
        <button class="btn" id="delete">Eliminar Nodo</button>
      </div>
      <div id="aristas">
        <button class="btn" id="draw-on">Crear Arista</button>
        <button class="btn" id="deleteAr">Eliminar Arista</button>
      </div>
      <div id="aristas2">
        <input id="nombre_arista" type="number">
        <button class="btn" id="asignar_valor">Asignar Valor de Arista</button>
      </div>
    </div>
    

  </body>

</html>
